package algod;

import java.util.ArrayList;

/**
 * File FIFO de messages AlgoDMessage
 * @author <A href=http://www.alapetite.fr.st>Alexandre Alapetite</A>, <A href=http://www.andujar.fr.st>Brice Andujar</A>, <A href=mailto:gregory.gontier@free.fr>Gregory Gontier</A>
 * @version 1.0
 * @see AlgoDMessage
 */
public class AlgoDMessageFIFO extends ArrayList implements AlgoDMessageFIFOinterface
{
  public AlgoDMessageFIFO()
  {
    super();
  }

  /**
   * Dfile un message de la file d'attente.
   * @return le plus ancien message de la file d'attente et le retire de la file.
   */
  public final synchronized AlgoDMessage pop()
  {
    return ((AlgoDMessage)super.remove(0));
  }

  /**
   * Regarde sans le supprimer de la file le plus ancien message.
   * @return le plus ancien message de la file d'attente sans le retirer.
   */
  public final synchronized AlgoDMessage peek()
  {
    return ((AlgoDMessage)super.get(0));
  }

  /**
   * Enfile un message dans la file d'attente.
   */
  public final synchronized void push(AlgoDMessage adm)
  {
    super.add(adm);
  }

  /**
   * Teste si la file est vide.
   * @return si la file est vide.
   */
  public final boolean empty()
  {
    return super.size()<=0;
  }

}
