package algod;

import java.util.BitSet;

/**
 * Dbut d'essai d'implmentation d'un BooleanVector avec des bits  la place des boolens.
 * @deprecated
 */
public class BitVector extends BitSet
{
  /**
   * Valeur par dfaut lors de la cration de nouvelles cases.
   */
  private final boolean defautValue;

  /**
   * Cre un nouveau tableau de boolean.
   * @param initialCapacity la taille initiale du tableau.
   * @param defautValue valeur avec laquelle les nouvelles cellules sont initialises.
   */
  public BitVector(int initialCapacity, boolean defautValue)
  {
    super(initialCapacity);
    this.defautValue = defautValue;
    if (defautValue) set(0,initialCapacity-1,defautValue);
  }

  /**
   * Cre un nouveau tableau de boolean. <BR>
   * Les nouvelles cellules sont initialises avec <CODE>false</CODE>.
   * @param initialCapacity la taille initiale du tableau.
   */
  public BitVector(int initialCapacity)
  {
    this(initialCapacity,false);
  }

  /**
   * Cre un nouveau tableau de boolean. <BR>
   * La taille initiale du tableau est de 10.<BR>
   * Les nouvelles cellules sont initialises avec <CODE>false</CODE>.
   */
  public BitVector()
  {
    this(10);
  }

  /**
   * Destructeur du tableau. Appel facultatif.
   */
  public void destroy()
  {

  }

  /**
   * Rinitialise tout le tableau avec la valeur par dfaut.
   */
  public final void clear()
  {
    set(0,super.length(),defautValue);//faux
  }

  /**
   * Change la taille du tableau. <BR>
   * Recopie les anciennes cellules et initialise les nouvelles avec <CODE>defautValue</CODE>.
   */
  final void setSize(int newSize)
  {

    //fill(temp.length,newSize-1,defautValue);
  }

  /**
   * Change la taille du tableau si ncessaire. <BR>
   * Agrandissement de 50%.
   * @see #setSize
   */
  final void setSizeIf(int minSize)
  {
    //if (minSize>table.length) setSize(3 * minSize / 2);
  }

  /**
   * Accs  un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @return la valeur du boolen  cet index.
   */
  public final boolean get(int index)
  {
    setSizeIf(index+1);
    return super.get(index);
  }

  /**
   * Change la valeur d'un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @param index index de l'lment modifi.
   * @param value valeur de l'lment.
   */
  public final void set(int index, boolean value)
  {
    setSizeIf(index+1);
    super.set(index,value);
  }

  /**
   * Met  <CODE>true</CODE> un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @param index index de l'lment modifi.
   */
  public final void set(int index)
  {
    set(index,true);
  }

  /**
   * Met  <CODE>false</CODE> un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @param index index de l'lment modifi.
   */
  public final void unset(int index)
  {
    set(index,false);
  }

  /**
   * Fait un et-logique sur un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @param index index de l'lment modifi.
   * @param value valeur avec laquelle le et-logique est effectu.
   */
  public final boolean and(int index, boolean value)
  {
    setSizeIf(index+1);
    if (value)
    {
      boolean temp = super.get(index);
      temp &= value;
      super.set(index,temp);
      return temp;
    }
    else
    {
      super.clear(index);
      return false;
    }
  }

  /**
   * Fait un ou-logique sur un lment du tableau. <BR>
   * Le tableau est agrandit si ncessaire.
   * @param index index de l'lment modifi.
   * @param value valeur avec laquelle le ou-logique est effectu.
   */
  public final boolean or(int index, boolean value)
  {
    boolean temp = super.get(index);
    temp |= value;
    super.set(index,temp);
    return temp;
  }

  /**
   * @return la taille du tableau.
   */
  public final int capacity()
  {
    return super.length();
  }

}
