package algod;

import java.awt.*;
import alxXML.*;

/**
 * Classe permettant de recharger des graphes au format XML.
 * @author <A href=http://www.alapetite.fr.st target=_blank>Alexandre Alapetite</A>
 * @version 3.0-
 * @see alxXML
 */
public class FileXML extends Object
{
  private AlxXMLdocument alxXMLdocument;

  private Graphe graphe;

  /** Lecture au format XML */
  public void readFromFile(Graphe graphe, String fileName)
  {
    this.graphe = graphe;
    alxXMLdocument = new AlxXMLdocument("");
    try
    {
      alxXMLdocument.readFromFile(fileName);
      loadGraph(alxXMLdocument.getMainElement().getElementList().getInFamille(0,"STATIC_GRAPH"));
    }
    catch(AlxXMLioException axie)
    {
      //System.out.println(axie); //dj fait dans les mthodes appelantes
    }
  }

  private int strToInt(String Str)
  {
    return ((Str!=null)&&(Str.length()>0)) ? Integer.parseInt(Str) : 0;
  }

  private void loadGraph(AlxXMLelement e)
  {
    int nbNode = e.getElementList().sizeFamille("NODE");
    for(int i=0;i<nbNode;i++)
      loadSommet(e.getElementList().getInFamille(i,"NODE"));
    for(int i=0;i<nbNode;i++)
      loadArretes(e.getElementList().getInFamille(i,"NODE"));
  }

  private void loadSommet(AlxXMLelement e)
  {
    int numSommet;
    String nom = e.getAttribut("Name");
    if ((nom.charAt(0)>='a') && (nom.charAt(0)<='z'))
      numSommet = (int)(nom.charAt(0)-'a');
    else numSommet = strToInt(nom);
    graphe.addSommet(numSommet,strToInt(e.getAttribut("X")),strToInt(e.getAttribut("Y")));
  }

  private void loadArretes(AlxXMLelement e)
  {
    int numSommet;
    String nom = e.getAttribut("Name");
    if ((nom.charAt(0)>='a') && (nom.charAt(0)<='z'))
      numSommet = (int)(nom.charAt(0)-'a');
    else numSommet = strToInt(nom);
    int nbArcs = e.getElementList().sizeFamille("ARCS");
    for(int i=0;i<nbArcs;i++)
      loadSucc(e.getElementList().getInFamille(i,"ARCS"),numSommet);
  }

  private void loadSucc(AlxXMLelement e, int numSommetOrigine)
  {
    int numSommetDestination;
    String nom = e.getAttribut("Destination");
    if ((nom.charAt(0)>='a') && (nom.charAt(0)<='z'))
      numSommetDestination = (int)(nom.charAt(0)-'a');
    else numSommetDestination = strToInt(nom);
    //int numSommetDestination = (int)(e.getAttribut("Destination").charAt(0)-'a');
    graphe.setArrete(numSommetOrigine,numSommetDestination);
  }

}
