package algod;

/**
 * Stoque les informations connues par un sommet sur un de ses voisins.
 * @author <A href=http://www.alapetite.fr.st>Alexandre Alapetite</A>, <A href=http://www.andujar.fr.st>Brice Andujar</A>, <A href=mailto:gregory.gontier@free.fr>Gregory Gontier</A>
 * @version 1.0
 */
public class SommetVoisin extends Object
{
  /**
   * File d'attente des messages provenant d'autres sommets.
   */
  private AlgoDMessageFIFOinterface algoDMessageFIFO;

  /**
   * Identifiant unique de ce sommet.
   */
  private final int identifiant;

  /**
   * Nouvel identifiant aprs l'arbre couvrant, qui correspond  une
   * numrotation en profondeur inverse.
   */
  private int identifiantProfondeur;

  /**
   * Couleur de ce sommet pour les problmes de coloration.
   */
  private int couleur;

  public SommetVoisin(AlgoDMessageFIFOinterface algoDMessageFIFO, int identifiant)
  {
    super();
    this.algoDMessageFIFO = algoDMessageFIFO;
    this.identifiant = identifiant;
  }

  /**
   * Nettoie l'objet avant un abandon au gc. Facultatif.
   */
  public void destroy()
  {
    algoDMessageFIFO = null;
  }

  public final int getIdentifiant()
  {
    return this.identifiant;
  }

  public final int getIdentifiantProfondeur()
  {
    return this.identifiantProfondeur;
  }

  public final void setIdentifiantProfondeur(int identifiantProfondeur)
  {
    this.identifiantProfondeur = identifiantProfondeur;
  }

  public final int getCouleur()
  {
    return this.couleur;
  }

  public final void setCouleur(int couleur)
  {
    this.couleur = couleur;
  }

  public final void recevoir(AlgoDMessage adm)
  {
    algoDMessageFIFO.push(adm);
  }

}
