package alxXML;

import java.io.IOException;

/**
 * Description : Signale qu'une erreur d'entre-sortie est survenue, ou que le fichier n'est pas ou n'a pas t compris comme tant du XML.
 * @author <A href=http://www.alapetite.fr.st target=_blank>Alexandre Alapetite</A>
 * @version 1.0 (06/2001)
 */
public class AlxXMLioException extends IOException
{
  /** Sauvegarde la ligne sur laquelle a t dtecte un erreur */
  private int ligne=-1;

  public AlxXMLioException()
  {
    super();
  }

  public AlxXMLioException(String s)
  {
    super(s);
  }

  /**
   * Cration d'une exception avec un le message d'erreur et la ligne sur laquelle a t dtecte l'erreur.
   * @param ligne la ligne sur laquelle a t dtecte un erreur.
   * @param s le message d'erreur expliquant ventuellement ce qui n'allait pas dans le document XML.
   */
  public AlxXMLioException(int ligne, String s)
  {
    this(s);
    this.ligne=ligne;
  }

  /** @return la ligne sur laquelle a t dtecte l'erreur, -1 si le champ n'a pas t renseign. */
  public int getLigneErreur()
  {
    return ligne;
  }

  public String toString()
  {
    String sTemp;
    if (ligne>=0) sTemp=("Erreur XML ligne "+Integer.toString(ligne)+" : ");
    else sTemp="";
    sTemp+=this.getMessage()+" ("+this.getClass().getName()+")";
    return sTemp;
  }

}
