package grapheanim;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Properties;

/** Panel de la fentre principale avec, entre autres la zone d'affichage des graphes. */
class Animate extends Component implements ActionListener, ItemListener, AdjustmentListener
{
  private DynamicGraphData stockage = new DynamicGraphData();
  private PopupMenu popup;
  private Frame frame;
  private Point dernierClick;
  private TextArea algo, commentaire;
  private CheckboxGroup cbg;
  private Image offscreen;
  private Scrollbar avancement, zoom, vitesseS;
  private AlgoRun algorun = null;
  private Button resetB, pauseB, runB, nextB, backB, exampleB, inB, outB;
  private Checkbox biparti, coloration, flots, DijkstraC, AaC, AC, LargeurC, LexicoC;
  private TextField avancementMin, avancementMax;
  private int vitesse = 1;

  public Animate (Frame frame)
  {
    this.frame = frame;
    this.frame.setLayout(new BorderLayout());

    popup = new PopupMenu();
    //creation de la partie "commandes + legende"
    Panel p2 = new Panel();
    p2.setLayout(new GridLayout(13, 1));
    this.frame.add(p2, BorderLayout.EAST);
    resetB = new Button("Reset");
    resetB.setEnabled(true);
    resetB.setActionCommand("reset");
    resetB.addActionListener(this);
    p2.add(resetB);
    pauseB = new Button("Pause");
    pauseB.setEnabled(false);
    pauseB.setActionCommand("pause");
    pauseB.addActionListener(this);
    p2.add(pauseB);
    runB = new Button("Run");
    runB.setEnabled(false);
    runB.setActionCommand("run");
    runB.addActionListener(this);
    p2.add(runB);
    nextB = new Button("Next");
    nextB.setEnabled(false);
    nextB.setActionCommand("next");
    nextB.addActionListener(this);
    p2.add(nextB);
    backB = new Button("Back");
    backB.setEnabled(false);
    backB.setActionCommand("back");
    backB.addActionListener(this);
    p2.add(backB);
    exampleB = new Button("Example");
    exampleB.setEnabled(true);
    exampleB.setActionCommand("example");
    exampleB.addActionListener(this);
    p2.add(exampleB);
    Color[] Couleur = new Color[] {Color.green, Color.blue, new Color(238,208,161),
                                   Color.red, Color.magenta, Color.white};
    String[] labels = new String[] {"sommet traite",
                                    "sommet choisi",
                                    "sommet ouvert",
                                    "sommet non explore",
                                    "sommet & arc modifie",
                                    "plus court chemin"};
    for (int i = 0; i < labels.length; i++)
    {
      Panel p2_1 = new Panel();
      p2_1.setLayout(new BorderLayout());
      Panel p2_11 = new Panel();
      p2_1.add(p2_11,BorderLayout.WEST);
      p2_11.add(new Rect(Couleur[i]));
      p2_1.add(new Label(labels[i]),BorderLayout.CENTER);
      p2.add(p2_1);
    }

    Panel p2_12 = new Panel();
    vitesseS = new Scrollbar(Scrollbar.HORIZONTAL, 1, 2, 0, 20);
    vitesseS.addAdjustmentListener(this);
    p2_12.add(vitesseS);
    p2_12.add(new Label("Vitesse"));
    p2.add(p2_12);

    //creation de la partie algo
    Panel p3 = new Panel();
    p3.setLayout(new FlowLayout());
    this.frame.add(p3, BorderLayout.NORTH);
    cbg = new CheckboxGroup();
    biparti = new Checkbox("Biparti", cbg, false);
    biparti.addItemListener(this);
    p3.add(biparti);
    coloration = new Checkbox("Coloration", cbg, false);
    coloration.addItemListener(this);
    p3.add(coloration);
    flots = new Checkbox("Flot", cbg, false);
    flots.addItemListener(this);
    p3.add(flots);
    DijkstraC = new Checkbox("Dijkstra", cbg, false);
    DijkstraC.addItemListener(this);
    p3.add(DijkstraC);
    AaC = new Checkbox("A*", cbg, false);
    AaC.addItemListener(this);
    p3.add(AaC);
    AC = new Checkbox("A", cbg, false);
    AC.addItemListener(this);
    p3.add(AC);
    LargeurC = new Checkbox("Largeur", cbg, false);
    LargeurC.addItemListener(this);
    p3.add(LargeurC);
    LexicoC = new Checkbox("Lexico", cbg, false);
    LexicoC.addItemListener(this);
    p3.add(LexicoC);

    //creation de la partie "Commentaires + barre d'avancement"
    Panel p4 = new Panel();
    p4.setBackground(Color.white.darker());
    p4.setLayout(new BorderLayout());
    this.frame.add(p4, BorderLayout.SOUTH);
    algo = new TextArea ("", 5, 31, 0);
    algo.setEditable(false);
    commentaire = new TextArea ("", 5, 31, 0);
    commentaire.setEditable(false);
    Panel p42 = new Panel();
    p42.setLayout(new GridLayout(1,2));
    p42.add(algo);
    p42.add(commentaire);
    p4.add (p42, BorderLayout.CENTER);
    Panel p41 = new Panel();
    p41.setBackground(Color.lightGray);
    p41.setLayout(new BorderLayout());
    p4.add(p41, BorderLayout.NORTH);
    Panel p45 = new Panel();
    p45.setLayout(new GridLayout(2,1));
    p41.add(p45,BorderLayout.WEST);
    avancementMin = new TextField("",3);
    avancementMin.addActionListener(this);
    p45.add(avancementMin);
    inB = new Button("-");
    inB.setActionCommand("in");
    inB.addActionListener(this);
    p45.add(inB);
    //p45 = new Panel();
    //p45.setLayout(new GridLayout(2,1));
    p41.add(p45,BorderLayout.EAST);
    avancementMax = new TextField("",3);
    avancementMax.setEditable(false);
    p45.add(avancementMax);
    outB = new Button("+");
    outB.setActionCommand("out");
    outB.addActionListener(this);
    p45.add(outB);
    avancement = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 0);
    avancement.addAdjustmentListener(this);
    zoom = new Scrollbar(Scrollbar.HORIZONTAL, 0, 0, 0, 0);
    zoom.addAdjustmentListener(this);
    Panel p43 = new Panel();
    p43.setLayout(new GridLayout(4, 1));
    p43.add(new Panel());
    p43.add(avancement);
    Panel p44 = new Panel();
    p44.setLayout(new BorderLayout());
    p43.add(p44);
    Panel p46 = new Panel();
    p46.setLayout(new FlowLayout());
    p46.add(new Label("Algorithme"));
    p46.add(new Label("Commentaire"));
    //p43.add(p46);
    p44.add(zoom, BorderLayout.CENTER);
    p41.add(p43, BorderLayout.CENTER);

    // Les events qui nous interessent
    this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
    this.enableEvents(AWTEvent.MOUSE_MOTION_EVENT_MASK);
    //this.enableEvents(AWTEvent.ITEM_EVENT_MASK);

    popup = new PopupMenu();
    this.add(popup);
    frame.setSize(640,400);
  }

  public void actionPerformed(ActionEvent event)
  {
    String command = event.getActionCommand();
    if (command.equals("imprimer")) imprimer(frame);
    else if (command.equals("in"))
    {
      zoom.setValue(avancement.getValue());
      zoom.setVisibleAmount(zoom.getVisibleAmount()/2);
      avancement.setMaximum(zoom.getValue()+zoom.getVisibleAmount());
      avancement.setMinimum(zoom.getValue());
      avancementMin.setText(String.valueOf(avancement.getValue()+1));
      avancementMax.setText(String.valueOf(avancement.getMaximum()-1));
    }
    else if (command.equals("out"))
    {
      zoom.setValue(avancement.getValue());
      zoom.setVisibleAmount(zoom.getVisibleAmount()*2);
      avancement.setMaximum(zoom.getValue()+zoom.getVisibleAmount());
      avancement.setMinimum(zoom.getValue());
      avancementMin.setText(String.valueOf(avancement.getValue()+1));
      avancementMax.setText(String.valueOf(avancement.getMaximum()-1));
    }
    else if (command.equals("sauver")) stockage.sauver(frame);
    else if (command.equals("ouvrir"))
    {
      reset();
      stockage.ouvrir(frame);
      if ((stockage.getAlgo() != "") || (stockage.getAlgo() != "editeur"))
      {
        if (stockage.getAlgo().equals("Flot"))
        {
          flots.setState(true);
          cbg.setSelectedCheckbox(flots);
        }
        else if (stockage.getAlgo().equals("Dijkstra"))
        {
          DijkstraC.setState(true);
          cbg.setSelectedCheckbox(DijkstraC);
        }
        else if (stockage.getAlgo().equals("A*"))
        {
          AaC.setState(true);
          cbg.setSelectedCheckbox(AaC);
        }
        else if (stockage.getAlgo().equals("A"))
        {
          AC.setState(true);
          cbg.setSelectedCheckbox(AC);
        }
        else if (stockage.getAlgo().equals("Largeur"))
        {
          LargeurC.setState(true);
          cbg.setSelectedCheckbox(LargeurC);
        }
        else if (stockage.getAlgo().equals("Lexico"))
        {
          LexicoC.setEnabled(true);
          cbg.setSelectedCheckbox(LexicoC);
        }
        else if (stockage.getAlgo().equals("Coloration"))
        {
          coloration.setEnabled(true);
          cbg.setSelectedCheckbox(coloration);
        }
        else if (stockage.getAlgo().equals("Biparti"))
        {
          coloration.setEnabled(true);
          cbg.setSelectedCheckbox(biparti);
        }
        avancement.setMaximum(stockage.nbrSteps()+1);
        avancement.setValue(stockage.getCurrentStepIndex());
        avancementMin.setText(String.valueOf(stockage.getCurrentStepIndex()+1));
        avancementMax.setText(String.valueOf(stockage.nbrSteps()+1));
        zoom.setMaximum(stockage.nbrSteps()+1);
        zoom.setVisibleAmount(stockage.nbrSteps()+1);
        runB.setEnabled(true);
        nextB.setEnabled(true);
        backB.setEnabled(true);
      }
      repaint();
    }
    else if (command.equals("reset")) reset();
    else if (command.equals("pause"))
    {
      if (algorun != null) algorun.stopper();
      algorun = null;
      nextB.setEnabled(true);
      backB.setEnabled(true);
      runB.setEnabled(true);
    }
    else if (command.equals("run"))
    {
      algorun = new AlgoRun(stockage, getGraphics(), avancement, backB, pauseB, runB,
          avancementMin, vitesse, offscreen, frame.getSize().width,
          frame.getSize().height, commentaire, algo);
      algorun.start();
      nextB.setEnabled(false);
      backB.setEnabled(false);
      pauseB.setEnabled(true);
    }
    else if (command.equals("next"))
    {
      if (algorun == null)
        algorun = new AlgoRun(stockage, getGraphics(), avancement,
                   backB, pauseB, runB, avancementMin,
                   vitesse, offscreen, frame.getSize().width,
                   frame.getSize().height, commentaire, algo);
      algorun.next();
      if (avancement.getMaximum()-1 > stockage.getCurrentStepIndex())
        nextB.setEnabled(true);
      else { nextB.setEnabled(false);
      runB.setEnabled(false); }
      backB.setEnabled(true);
    }
    else if (command.equals("back"))
    {
      if (algorun == null)
        algorun = new AlgoRun(stockage, getGraphics(), avancement,
                  backB, pauseB, runB, avancementMin,
                  vitesse, offscreen, frame.getSize().width,
                  frame.getSize().height, commentaire, algo);
      algorun.previous();
      if (avancement.getMinimum() < stockage.getCurrentStepIndex())
        backB.setEnabled(true);
      else backB.setEnabled(false);
      nextB.setEnabled(true);
      runB.setEnabled(true);
    }
    else if (command.equals("example")) example();
    else if (command.equals("origine")) origine();
    else if (command.equals("arrivee")) arrivee();
    else if ((Integer.parseInt(command)>0)&&(Integer.parseInt(command)<=avancement.getMaximum()))
    {
      stockage.setCurrentStepIndex(Integer.parseInt(command)-1);
      repaint();
      avancement.setValue(Integer.parseInt(command)-1);
      if (Integer.parseInt(command) == avancement.getMaximum())
      {
        nextB.setEnabled(false);
        runB.setEnabled(false);
        backB.setEnabled(true);
      }
      else if (Integer.parseInt(command)==1)
      {
        backB.setEnabled(false);
        nextB.setEnabled(true);
        runB.setEnabled(true);
      }
      else
      {
        nextB.setEnabled(true);
        runB.setEnabled(true);
        backB.setEnabled(true);
      }
    }
  }

  public void itemStateChanged(ItemEvent event)
  {
    String s = cbg.getSelectedCheckbox().getLabel();
    stockage.setAlgo(s);
    pauseB.setEnabled(false);
    runB.setEnabled(false);
    nextB.setEnabled(false);
    backB.setEnabled(false);
    algorun = null;
    avancementMax.setText("");
    avancementMin.setText("");
    avancement.setMaximum(0);
    zoom.setMaximum(0);
    stockage.Init(stockage.getInitGraph(), 0, 0);
    stockage.gotoFirstStep();
    repaint();
  }

  public void adjustmentValueChanged(AdjustmentEvent event)
  {
    if (event.getAdjustable() == avancement)
    {
      stockage.setCurrentStepIndex(event.getValue());
      avancementMin.setText(String.valueOf(avancement.getValue()+1));
      repaint();
      if (event.getValue()>0)
      {
        commentaire.append(stockage.getStepAt(event.getValue()-1).getCommentaire());
        algo.append(stockage.getStepAt(event.getValue()-1).getAlgo());
      }
      if (avancement.getMinimum()==avancement.getValue()) backB.setEnabled(false);
      else backB.setEnabled(true);
      if (avancement.getMaximum() == avancement.getValue()+1)
      {
        runB.setEnabled(false);
        nextB.setEnabled(false);
      }
      else
      {
        runB.setEnabled(true);
        nextB.setEnabled(true);
      }
    }
    else if (event.getAdjustable() == vitesseS)
    {
      vitesse = vitesseS.getValue();
      if(algorun!=null)
      {
        algorun.setVitesse(vitesse);
      }
    }
    else if (event.getAdjustable()==zoom)
    {
      if (avancement.getMinimum()<event.getValue())
        avancement.setMaximum(avancement.getMaximum()+1);
      else avancement.setMaximum(avancement.getMaximum()-1);
      avancement.setMinimum(event.getValue());
      avancement.setValue(avancement.getMinimum());
      stockage.setCurrentStepIndex(avancement.getValue());
      avancementMin.setText(String.valueOf(avancement.getMinimum()+1));
      avancementMax.setText(String.valueOf(avancement.getMaximum()+1));
      repaint();
    }
  }

  public void paint(Graphics g)
  {
    //if(offscreen == null)
      offscreen = createImage(getSize().width, getSize().height);
    Graphics og = offscreen.getGraphics();
    og.setColor(Color.lightGray);
    og.fillRect(0,0,getSize().width, getSize().height);
    og.setClip(0,0,getSize().width, getSize().height);
    stockage.afficher(og);
    g.drawImage(offscreen,0,0,null);
    og.dispose();
  }

  // appelee lorsqu'il y a un MouseEvent
  public void processMouseEvent(MouseEvent e)
  {
    if (e.isMetaDown() || e.isPopupTrigger())  //si le bouton droit est enfonc
    {
      dernierClick = new Point(e.getX(), e.getY());
      Sommet s = stockage.getInitGraph().getSommet(new Point(e.getX(), e.getY()));
      if (s != null) sommetOptionPopup(true, s);
      else sommetOptionPopup(false, s);
      popup.show(this, e.getX(), e.getY());
    }
    /*else if ((e.getID()==MouseEvent.MOUSE_CLICKED)||(e.getID()==MouseEvent.MOUSE_PRESSED))
      dernierClick = new Point(e.getX(), e.getY());
    else if (e.getID() == MouseEvent.MOUSE_RELEASED)
    {

    }*/
    else super.processMouseEvent(e); // donner a la superclasse pour l'action par defaut
  }

  // appelee losrqu'il y a un MouseMotionEvent
  public void processMouseMotionEvent(MouseEvent e)
  {
    if (e.getID() == MouseEvent.MOUSE_DRAGGED) {}
    // important ! donner a la superclasse pour l'action par defaut
    else super.processMouseMotionEvent(e);
  }

  private void sommetOptionPopup(boolean b, Sommet s)
  {
    String[] labels = new String[] { "Imprimer", "Sauver", "Ouvrir"};
    String[] commandes = new String[] { "imprimer", "sauver", "ouvrir"};
    popup.removeAll();
    for(int i = 0; i < labels.length; i++)
    {
      MenuItem mi = new MenuItem(labels[i]);
      mi.setActionCommand(commandes[i]);
      mi.addActionListener(this);
      popup.add(mi);
    }
    if (b)
    {
      if ((stockage.getAlgo().equals("Flot")) ||
          (stockage.getAlgo().equals("A*")) ||
          (stockage.getAlgo().equals("A")))
      {
        labels = new String[] {"Origine", "Arrivee"};
        commandes = new String[] {"origine", "arrivee"};
      }
      else if ((stockage.getAlgo().equals("Dijkstra")) ||
            (stockage.getAlgo().equals("Largeur")) ||
            (stockage.getAlgo().equals("Coloration")) ||
            (stockage.getAlgo().equals("Lexico"))||
            (stockage.getAlgo().equals("Biparti")))
      {
       labels = new String[] {"Origine"};
       commandes = new String[] {"origine"};
      }
      else return; //erreur de XML
      popup.addSeparator();
      for (int i = 0; i < labels.length; i++)
      {
        MenuItem mi = new MenuItem(labels[i]);
        mi.setActionCommand(commandes[i]);
        mi.addActionListener(this);
        popup.add(mi);
      }
    }
  }

  public void algo()
  {
    stockage.setSteps(new Vector());
    if (cbg.getSelectedCheckbox() != null)
    {
      commentaire.append("Algo : ".concat(stockage.getAlgo().concat("\n")));
      if (stockage.getOrigine() == "")
         commentaire.append("Pas d'origine selectionne\n");
      else if ( stockage.getArrivee().equals("") &&
                (stockage.getAlgo().equals("Flot") ||
                 stockage.getAlgo().equals("A*") ||
                 stockage.getAlgo().equals("A")
                ))
         commentaire.append("Pas d'arrivee selectionne\n");
      else
      {
        if (stockage.getAlgo().equals("Biparti"))
        {
          commentaire.append("Algo de couplage");
          Biparti B = new Biparti(stockage);
          B.Initialiser();
          B.Explorer();
        }
        else if (stockage.getAlgo().equals("Coloration"))
        {
          Coloration coloration = new Coloration(stockage);
          coloration.Initialiser();
          coloration.Explorer();
          //coloration.Afficher();
        }
        else if (stockage.getAlgo().equals("Flot"))
        {
          FordFulkerson F = new FordFulkerson(stockage);
          F.Initialiser();
          F.Explorer();
          //F.Afficher();
        }
        else if (stockage.getAlgo().equals("Dijkstra"))
        {
          Dijkstra D = new Dijkstra(stockage);
          D.Initialiser();
          D.Explorer();
          D.Afficher();
        }
        else if (stockage.getAlgo().equals("A*"))
        {
          A a = new A(stockage);
          a.Initialiser();
          a.Explorer();
          a.Afficher();
        }
        else if (stockage.getAlgo().equals("A"))
        {
          A_vol avol = new A_vol(stockage);
          avol.Initialiser();
          avol.Explorer();
          avol.Afficher();
        }
        else if (stockage.getAlgo().equals("Largeur"))
        {
          Largeur largeur = new Largeur(stockage);
          largeur.Initialiser();
          largeur.Explorer();
          largeur.Afficher();
        }
        else if (stockage.getAlgo().equals("Lexico"))
        {
          Lexico lexico = new Lexico(stockage);
          lexico.Initialiser();
          lexico.Explorer();
          lexico.Afficher();
        }
        //new FileXML().SaveToFile("temp.xml", stockage);
        avancementMax.setText(String.valueOf(stockage.nbrSteps()+1));
        avancementMin.setText("1");
        avancement.setMaximum(stockage.nbrSteps()+1);
        avancement.setValue(0);
        zoom.setMaximum(stockage.nbrSteps()+1);
        zoom.setVisibleAmount(stockage.nbrSteps()+1);
        runB.setEnabled(true);
        nextB.setEnabled(true);
        repaint();
      }
    }
  }

  public void example()
  {
    reset();
    FileXML f = new FileXML();
    DynamicGraphData d = f.ReadFromFile("exemples/zz_nico.grf");
    if (d != null)
    {
      stockage = new DynamicGraphData(d);
      repaint();
      if (cbg.getSelectedCheckbox() != null)
          cbg.setSelectedCheckbox(new Checkbox(cbg.getSelectedCheckbox().getLabel(),cbg,false));
    }
    /** @todo a faire dans une boite de dialogue */
    else System.out.println(f.getLastError());
  }

  public void origine()
  {
    Graphics g = getGraphics();
    if (stockage.getOrigine().length()>0)
    {
      g.clipRect(stockage.getInitGraph().getSommet(stockage.getOrigine()).getX(),
        stockage.getInitGraph().getSommet(stockage.getOrigine()).getY(), 30, 30);
      stockage.setOrigine("");
      paint(g);
      g = getGraphics();
    }
    stockage.Init(stockage.getInitGraph(), 0, 0);
    stockage.gotoFirstStep();

    stockage.setOrigine(stockage.getInitGraph().getSommet(dernierClick).getNom());

    commentaire.append("Sommet Origine : ");
    commentaire.append(stockage.getOrigine()+"\n");
    g.clipRect(stockage.getInitGraph().getSommet(stockage.getOrigine()).getX(),
               stockage.getInitGraph().getSommet(stockage.getOrigine()).getY(), 30, 30);
    paint(g);
    if (cbg.getSelectedCheckbox().getState()) algo();
  }

  public void arrivee()
  {
    Graphics g = getGraphics();
    if (stockage.getArrivee().length()>0)
    {
      g.clipRect(stockage.getInitGraph().getSommet(stockage.getArrivee()).getX(),
                  stockage.getInitGraph().getSommet(stockage.getArrivee()).getY(), 30, 30);
      stockage.setArrivee("");
      paint(g);
      g = getGraphics();
    }
    stockage.Init(stockage.getInitGraph(), 0, 0);
    stockage.gotoFirstStep();

    stockage.setArrivee(stockage.getInitGraph().getSommet(dernierClick).getNom());
    commentaire.append("Sommet Arrivee : ");
    commentaire.append(stockage.getArrivee().concat("\n"));
    g.clipRect(stockage.getInitGraph().getSommet(stockage.getArrivee()).getX(),
                stockage.getInitGraph().getSommet(stockage.getArrivee()).getY(), 30, 30);
    paint(g);
    if (cbg.getSelectedCheckbox().getState()) algo();
  }

  public void reset()
  {
    DijkstraC.setState(false);
    AaC.setState(false);
    AC.setState(false);
    LargeurC.setState(false);
    LexicoC.setState(false);
    pauseB.setEnabled(false);
    runB.setEnabled(false);
    nextB.setEnabled(false);
    backB.setEnabled(false);
    algorun = null;
    avancementMax.setText("");
    avancementMin.setText("");
    avancement.setMaximum(0);
    zoom.setMaximum(0);
    stockage.setOrigine("");
    stockage.setArrivee("");
    stockage.setAlgo("");
    stockage.Init(stockage.getInitGraph(), 0, 0);
    stockage.gotoFirstStep();
    if (cbg.getSelectedCheckbox() != null)
             cbg.setSelectedCheckbox(new Checkbox(cbg.getSelectedCheckbox().getLabel(),cbg,false));
    repaint();
    commentaire.append("\n--- RESET ---\n");
  }

  private void imprimer(Frame fr)
  {
    Toolkit toolkit = this.getToolkit();
    // "new Properties()" sert a garder les options choisies dans la boite dialogue
    PrintJob job = toolkit.getPrintJob(fr, "Graphe", new Properties());
    if (job == null) return;
    Graphics page = job.getGraphics();
    Dimension taille = this.getSize();
    Dimension taillePage = job.getPageDimension();
    // centrer la page sur la feuille
    page.translate((taillePage.width - taille.width)/2,
             (taillePage.height - taille.height)/2);
    page.drawRect(0, 0, taille.width, taille.height);
    // necessaire pour que le graphe ne sorte pas de la feuille...
    page.setClip(0, 0, taille.width, taille.height);
    this.print(page);
    page.dispose();
    job.end();
  }

}
