package grapheanim;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.math.*;

/** Fentre principale du logiciel */
public class Anime extends Frame implements ActionListener, WindowListener
{
  protected static int nbr_fenetre = 0;   //nbr de fenetre ouverte, si == 0 on quitte
  private MenuItem nouveau, fermer, quitter, propos, editeur, dialogAlgo;

  // Cree une Frame, un Menu, et un ScrollPane pour le component Graphe
  public Anime(int i)
  {
    // Creation de la fenetre
    super("Animation de graphe");
    setLayout (new FlowLayout());
    nbr_fenetre++;
    if (i != 0) nbr_fenetre = i + 1;
    // creation de la partie "animate"
    ScrollPane pane = new ScrollPane();
    Animate animate = new Animate(this);
    pane.add(animate);
    this.add(pane);
    // Creation de la barre de menu
    MenuBar leMenu = new MenuBar();
    this.setMenuBar(leMenu);
    Menu fichier = new Menu("Fichier");
    leMenu.add(fichier);
    Menu aide = new Menu("Aide");
    leMenu.add(aide);
    fichier.add(nouveau = new MenuItem("Nouveau Anime", new MenuShortcut(KeyEvent.VK_A)));
    fichier.add(fermer = new MenuItem("Fermer Anime",new MenuShortcut(KeyEvent.VK_F)));
    fichier.add(editeur = new MenuItem("Nouveau Editeur", new MenuShortcut(KeyEvent.VK_E)));
    fichier.addSeparator();
    fichier.add(quitter = new MenuItem("Quitter", new MenuShortcut(KeyEvent.VK_Q)));
    aide.add(propos = new MenuItem("A propos"));
    aide.add(dialogAlgo = new MenuItem("DialogAlgo"));
    nouveau.addActionListener(this);
    fermer.addActionListener(this);
    quitter.addActionListener(this);
    propos.addActionListener(this);
    editeur.addActionListener(this);
    dialogAlgo.addActionListener(this);
    // permet de fermer le programme avec la croix  de la fenetre
    this.addWindowListener(this);
    // affichage de la fenetre
    this.pack();
    this.setBounds(50,50,750,550);
    this.show();
  }

  /** vnement de fermeture */
  public void windowClosing(WindowEvent evt)
  {
    if (--nbr_fenetre == 0) System.exit(0);
    else dispose();
  }
  public void windowClosed(WindowEvent evt) { }
  public void windowDeiconified(WindowEvent evt) { }
  public void windowIconified(WindowEvent evt) { }
  public void windowActivated(WindowEvent evt) { }
  public void windowDeactivated(WindowEvent evt) { }
  public void windowOpened(WindowEvent evt) { }

  public void  actionPerformed (ActionEvent evt)
  {
    Object obj = evt.getSource();
    if (obj == nouveau) new Anime(0);
    else if (obj == dialogAlgo) new DialogAlgo("Algorithme Dijsktra");
    else if (obj == editeur) new Editeur(nbr_fenetre);
    else if (obj == quitter) System.exit(0);
    else if (obj == propos) new APropos(this, "Animation de graphe\n\nSujet repris en Juin 2001 et complt avec les algorithmes de Coloration et de Flot par les tudiants d'IUP GMI 2 Montpellier:\n  Delphine\n  Alexandre Alapetite : alapetite@fr.st\n  Brice Andujar : andujar@fr.st\n  Nicolas");
    else if (obj == fermer) windowClosing(null);
  }

  public static void main(String[] args)
  {
    new Anime(0);
  }

}

