package grapheanim;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/** Fentre avec un texte dcrivant un parcours gnrique. */
class DialogAlgo extends Frame implements ActionListener, WindowListener
{
  private Button btValider, btQuitter;
  private boolean ok;

  DialogAlgo(String titre)
  {
    super(titre);
    setSize(400, 700);
    setResizable(false);
    this.addWindowListener(this);
    setLayout(new BorderLayout());
    Panel panelButtonSouth = new Panel(new GridLayout (1,2));
    btValider = new Button("Valider");
    btValider.setFont (new Font("Helvetica",Font.PLAIN,20));
    btValider.setEnabled (false);
    btValider.addActionListener(this);

    btQuitter = new Button("Quitter");
    btQuitter.setFont (new Font("Helvetica",Font.PLAIN,20));
    btQuitter.addActionListener(this);

    panelButtonSouth.add (btQuitter);
    panelButtonSouth.add (btValider);

    add (panelButtonSouth,BorderLayout.SOUTH);
    setBackground (Color.white);
    ok = false;
    pack();
    show();
  }

  /** vnement de fermeture */
  public void windowClosing(WindowEvent evt)
  {
    dispose();
  }
  public void windowClosed(WindowEvent evt) { }
  public void windowDeiconified(WindowEvent evt) { }
  public void windowIconified(WindowEvent evt) { }
  public void windowActivated(WindowEvent evt) { }
  public void windowDeactivated(WindowEvent evt) { }
  public void windowOpened(WindowEvent evt) { }

  public void actionPerformed(ActionEvent evt)
  {
    Object source = evt.getSource();
    if(source == btValider)
    {
      ok = true;
      setVisible(false);
    }
    else if (source == btQuitter)
    {
      ok = false;
      setVisible(false);
    }
  }

  public void paint (Graphics g)
  {
    String titre1, titre2, donnee, resultat, init1,init2,init3,init4,init5,init6,init7,init8,init9,init10,init11,etap11,etap12,etap13,etap14,etap21,etap22,etap23,etap24,etap31,etap32,etap33,etap34,etap35;

    titre1 = "L'algorithme:";
    titre2 = "Algorithme de Parcours Generique.";
    donnee = "Donnees: un graphe oriente G = (X, U), une fonction de cout w : U -> T.";
    resultat = "Resultats: une arborescence des plus courts chemins issus de x";
    init1 = "OUVERTS <- {x}";
    init2 = "FERMES <- NIL";
    init3 = "Parent(x) <- NIL";
    init4 = "Pour tout y est different que x, alors Parent(y) <- y";
    init5 = "d(x) <- (l'element minmal de T";
    init6 = "tant que OUVERTS est different que NIL faire";
    init7 = " | z <- Choix(OUVERTS)";
    init8 = " | Ajout(z, FERMES)";
    init9 = " | Exmprer(z)";
    init10= " | Virer(z, OUVERTS)";
    init11= " |";

    etap11 = "Explorer(z)";
    etap12 = "Pour Tous les voisins y de z faire";
    etap13 = " | si y appartient FERMES alors";
    etap14 = " |   -Ne rien faire";
    etap21 = " | si y appartient OUVERTS alors";
    etap22 = " |  | si d(z) + w(z, y) < d(y) alors";
    etap23 = " |  |  | Parent(y) <- z";
    etap24 = " |  |  | d(y) <- d(z) + w(z, y )";

    etap31 = " |  sinon";
    etap32 = " |  | Ajout(y, OUVERTS)";
    etap33 = " |  | Parent(y) <- z";
    etap34 = " |  | d(y) <- d(z) + w(z, y)";
    etap35 = " |";

    g.setFont(new Font("Helvetica",Font.BOLD,8)); //Font("TimesRoman", Font.BOLD, 8));
    g.drawString(titre1,20,50);
    g.drawString(titre2,20,70);
    g.drawString(donnee,20,90);
    g.drawString(resultat,20,110);
    g.setColor(Color.red);
    g.drawString(init1,20,150);
    g.drawString(init2,20,170);
    g.drawString(init3,20,190);
    g.drawString(init4,20,210);
    g.drawString(init5,20,230);
    g.drawString(init6,20,250);
    g.drawString(init7,40,270);
    g.drawString(init8,40,290);
    g.drawString(init9,40,310);
    g.drawString(init10,40,330);
    g.drawString(init11,40,350);

    g.setColor(Color.blue);
    g.drawString(etap11,20,390);
    g.drawString(etap12,20,410);
    g.drawString(etap13,20,430);
    g.drawString(etap14,20,450);
    g.drawString(etap21,20,470);
    g.drawString(etap22,20,490);
    g.drawString(etap23,20,510);
    g.drawString(etap24,20,530);

    g.drawString(etap31,20,550);
    g.drawString(etap32,20,570);
    g.drawString(etap33,20,590);
    g.drawString(etap34,20,610);
    g.drawString(etap34,20,630);
  }

  /*public static void main(String argv[])
  {
    DialogAlgo MonGraphe=new DialogAlgo("Algorithme Dijsktra");
  }*/
}


