package grapheanim;

import java.awt.*;
import java.io.*;
import java.util.Vector;

/**
 * Classe permettant de sauver une tape d'un algorithme.
 * @see DynamicGraphData#addStep
 */
public class DynamicData implements Serializable
{
  private Vector OldSommets;
  private Vector NewSommets;
  private Vector OldArcs;
  private Vector NewArcs;
  private String commentaire, algo;

  //les constructeurs
  DynamicData()
  {
    OldSommets = new Vector();
    NewSommets = new Vector();
    OldArcs = new Vector();
    NewArcs = new Vector();
    commentaire = algo = "";
  }

  //les accesseurs
  public Vector getNewSommets() { return NewSommets; }
  public Vector getOldSommets() { return OldSommets; }
  public Vector getNewArcs() { return NewArcs; }
  public Vector getOldArcs() { return OldArcs; }
  public void setCommentaire(String s) { commentaire =s; }
  public String getCommentaire() { return commentaire; }
  public void setAlgo(String s) { algo = s; }
  public String getAlgo() { return algo; }

  void addArc(Successeur Old, Successeur New)
  {
    OldArcs.addElement(Old);
    NewArcs.addElement(New);
  }

  void addSommet(Sommet Old, Sommet New)
  {
    OldSommets.addElement(Old);
    NewSommets.addElement(New);
  }

}
