package grapheanim;

import java.io.*;
import java.lang.*;
import java.lang.Object;
import java.util.*;
import java.awt.*;

/** Algorithme de parcours en largeur. */
public class Largeur extends Methode_Generale
{
  protected int numero;
  protected int numerocouche;

  //Constructeur
  Largeur(DynamicGraphData dgd)
  {
    super(dgd);
    numero = 0;
    numerocouche = 0;
  }

  //Methodes (on gere la file comme une file FIFO)
  public void Insertion(String z) //on insere en fin de file
  {
    int place = get_nb_ouverts();
    INSERT_O(z, 0, place);
    NOM(z).set_ouverts(true);
    NOM(z).setCouleur(Color.red);
    nb_ouverts++;
  }

  public void Virez(String z) // on enleve le premier de la file
  {
    NOM(z).set_ouverts(false);
    nb_ouverts--;
    Ouverts.removeElementAt(0);
  }

  public void Explorer()
  {
    while (!Ouverts.isEmpty())
    {
      String z = Choix();
      NOM(z).set_Dist(numero);
      SauverCouleurSommet(Color.blue, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix(OUVERTS)    <--\n   | Ajout(" + z + ", FERMES)            <--\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)", "\nOn va affecter le sommet '" + z + "' du numero: " + numero + "\n\n");
      numero++;
      Ajout(z);
      Exploration(z);
      Virez(z);
      int c = NOM(z).getCouche();
      int r = 0;
      int g = 255 - c*50;
      int b = c * 50;
      Color C = new Color(r,g,b);
      SauverCouleurSommet(C, z, "\ntant que OUVERTS != {} faire\n   | " + z + " <- Choix(OUVERTS)\n   | Ajout(" + z + ", FERMES)\n   | Explorer(" + z + ")\n   | Virez(" + z + ",OUVERTS)            <--", "\nOn vient de traiter la " + numerocouche + " couche du graphe\nA chaque tape une nouvelle couche sera traite\n\n");
    }
    DynamicData DD = new DynamicData();
    DD.setAlgo("\n\n     FIN de l'algorithme de\n     parcours en largeur!!\n\n");
    DD.setCommentaire("\nA la fin on obtient bien une numerotation \ncompatible des sommets.\n\nRq: les differentes couleurs representent les differentes\n couches du graphe");
    get_DGD().addStep(DD);
  }

  public void Exploration(String z)
  {
    Sommet a = NOM(z);
    int compteur = a.nbrSuccesseur();
    Vector clone = (Vector)NOM(z).getAllSuccesseurs().clone(); //cre un clone des successeurs
    Sommet OldOld = NOM(z).clonePoints(); //on enregistre l'ancien pred

    while (compteur != 0) //parcour de tous les successeurs
    {
      int i = Aleatoire(compteur);
      Successeur s = (Successeur)clone.elementAt(i);
      String nom = s.getNom();

      if (NOM(nom).get_fermes() == false && NOM(nom).get_ouverts() == false)
      {
        DynamicData DD = new DynamicData();
        Sommet Old = NOM(nom).clonePoints(); //on enregistre l'ancien Point;
        Insertion(nom);
        NOM(nom).setCouleur(beige);
        NOM(nom).set_Parent(z);
        Sommet New = NOM(nom).clonePoints(); //on enregistre le nouveau Point;
        DD.addSommet(Old, New);

        NOM(z).getSuccesseur(nom).setCouleur(Color.white);
        Sommet NewNew = NOM(z).clonePoints();
        DD.addSommet(OldOld, NewNew);

        OldOld = NewNew;
        NOM(nom).setCouche(NOM(z).getCouche() + 1);
        DD.setAlgo("\npour tous les voisins y de " + z + " faire\n   .....\n    sinon\n      | numeroter(" + nom + ")     <--\n      | Ajout (" + nom + ", OUVERTS)  <--");
        DD.setCommentaire("\nOn choisit un sommet au hasard parmi ses voisins\nLe sommet trait ne sera pas rouverts comme\n c'est le cas dans l'algorithme A*\n\n le voisin trait est '" + nom + "'");
        get_DGD().addStep(DD);
      }
      /*else
      {
        if (NOM(nom).get_fermes()) {}
        else
        {
            if (NOM(nom).get_ouverts()) {}
        }
      }*/
      clone.removeElementAt(i);
      compteur--;
    }
  }

  public void Afficher()
  {
    System.out.println("\nVille de depart " + get_Ville_depart() + "\n");
    System.out.println("---------------");
    System.out.println("Voici la liste des parents de chacune des villes");
    System.out.println("-----------------------------------------------\n");
    for (int i=0;i<Taille();i++)
    {
      Sommet p = GD().sommetAt(i);
      System.out.println("Ville : " + p.get_Nom());
      System.out.println("Parent : " + p.get_Parent());
      System.out.println("numero de sommet : " + p.get_Dist() + "\n");
    }
  }

}
