package grapheanim;

import java.awt.*;
import java.awt.event.*;
import java.lang.String.*;

/** Fentre de dialogue permettant une saisie de valeur par l'utilisateur. */
class PetiteBoite extends Dialog implements ActionListener, WindowListener
{
  private Button set, annuler;
  private TextField texte;
  /** sommet de dpart de l'arc */
  private Sommet s;
  /** successeur = sommet d'arrive de l'arc */
  private Successeur successeur;
  private GrapheData stockage;
  /** nom du successeur = sommet d'arrive de l'arc */
  private String st2;
 // private String title;

  PetiteBoite (Frame fr, GrapheData gr, Point p, String title, String st2a)
  {
    super(fr,title);
    //this.title=title;
    this.setLayout(new BorderLayout());
    this.stockage = gr;
    this.st2 = st2a;
    this.s = stockage.getSommet(p);
    if (s!=null)
    {
      this.successeur = s.getSuccesseur(st2);
      Panel p1 = new Panel();
      p1.setLayout(new BorderLayout());
      if (st2.equals("Nom")) texte = new TextField(s.getNom());
      else if (st2.equals("Heuristique"))
        texte = new TextField(String.valueOf(s.getHeuristique()));
      else if (title.indexOf("Flot")>0)
        texte = new TextField(String.valueOf(successeur.getFlot()));
      else texte = new TextField (String.valueOf(successeur.getPoid()));
      p1.add(texte, BorderLayout.CENTER);
      Panel p2 = new Panel();
      set = new Button("Set");
      p2.add(set);
      annuler = new Button("Annuler");
      p2.add(annuler);
      set.addActionListener(this);
      annuler.addActionListener(this);
      add(p1, BorderLayout.NORTH);
      add(p2, BorderLayout.SOUTH);
      this.addWindowListener(this);
      pack();
      Rectangle rect = fr.getBounds();
      rect.width=160;
      rect.height=80;
      rect.x+=50;
      rect.y+=100;
      this.setBounds(rect);
      show();
      texte.setSelectionStart(0);
      texte.setSelectionEnd(s.getNom().length()+1);
    }
    else dispose();
  }

  /** vnement de fermeture */
  public void windowClosing(WindowEvent evt)
  {
    dispose();
  }
  public void windowClosed(WindowEvent evt) { }
  public void windowDeiconified(WindowEvent evt) { }
  public void windowIconified(WindowEvent evt) { }
  public void windowActivated(WindowEvent evt) { }
  public void windowDeactivated(WindowEvent evt) { }
  public void windowOpened(WindowEvent evt) { }

  public void  actionPerformed (ActionEvent evt)
  {
    Object obj = evt.getSource();
    if (obj == set)
    {
      if (texte.getText() != null)
        if (st2.equals("Nom")) stockage.renameSommet(s,texte.getText());
        else
        {
          int valeur=Integer.parseInt(texte.getText());
          if (st2.equals("Heuristique")) stockage.getSommet(s.getNom()).setHeuristique(valeur);
          else if ((this.getTitle().indexOf("Flot")>0)&&(valeur<100)&&(valeur>=0))
            stockage.changeFlotSuccesseur(s, stockage.getSommet(st2), Math.min(valeur,s.getSuccesseur(st2).getPoid()));
          else if ((this.getTitle().indexOf("poid")>0)&&(valeur<100)&&(valeur>=0))
          {
            stockage.changeFlotSuccesseur(s, stockage.getSommet(st2),Math.min(valeur,s.getSuccesseur(st2).getFlot()));
            stockage.changePoidSuccesseur(s, stockage.getSommet(st2),valeur);
          }
          else System.out.println("/!\\ PetiteBoite.actionPerformed : erreur");
        }
      dispose();
    }
    else if (obj == annuler) dispose();
    //dispose();
  }
}
