package grapheanim;

import java.awt.*;
import java.io.*;

/**
 * Classe permettant de sauver un successeur d'un sommet.
 * @see Sommet#getSuccesseur
 */
public class Successeur extends Object implements Serializable
{
  private String nom;
  private int poid;
  private int flot;
  private int coloration;
  private Color couleur;
  private boolean couple;

  //les constructeurs
  public Successeur()
  {
    this("",0);
  }

  public Successeur(String s, int i)
  {
    this(s,i,0);
  }

  public Successeur(String s, int i, int f)
  {
    super();
    nom = s;
    poid = i;
    flot = f;
    couleur = Color.black;
  }

  public Successeur(Successeur succ)
  {
    this(succ.getNom(),succ.getPoid(),succ.getFlot());
    couleur = succ.getCouleur();
  }

  //les accesseurs
  public String getNom() { return nom; }
  public void setNom(String s) { nom = s; }
  public Color getCouleur() { return couleur; }
  public void setCouleur(Color c) { couleur = c; }
  public int getPoid() { return poid; }
  public void setPoid(int i) { poid = i; }
  public int getFlot() { return flot; }
  public void setFlot(int i) { flot = i; }
  public int getColoration() { return coloration; }
  public void setColoration(int i) { coloration = i; }
  public boolean getCouple(){return couple;}
  public void setCoupleTrue(){couple=true;}
  public void setCoupleFalse(){couple=false;}
  public String toString()
  {
    return nom+"("+flot+"/"+poid+")";
  }
}
