package graphelastic;

import java.awt.Color;
import java.awt.Graphics;

/**
 * Arrte reliant deux sommets.
 * @see Node
 * @see algod.Sommet
 */
class Edge extends Object
{
  /**
   * <CODE>Node</CODE> de dpart de l'arrte.
   */
  Node nodeFrom;

  /**
   * <CODE>Node</CODE> d'arrive de l'arrte.
   */
  Node nodeTo;

  /**
   * Longueur voulue de l'arrte.
   */
  double len;

  public void relax()
  {
    double vx = nodeTo.x - nodeFrom.x;
    double vy = nodeTo.y - nodeFrom.y;
    double dlen = Math.sqrt(vx * vx + vy * vy);
    if (dlen<=0) dlen = 0.0001;
    double f = (len - dlen) / (dlen * 3);
    double dx = f * vx;
    double dy = f * vy;
    nodeTo.dx += dx;
    nodeTo.dy += dy;
    nodeFrom.dx += -dx;
    nodeFrom.dy += -dy;
  }

  public void paint(Graphics g)
  {
    if (nodeFrom.sommet.isFilsDe(nodeTo.sommet.getIdentifiant())||nodeTo.sommet.isFilsDe(nodeFrom.sommet.getIdentifiant()))
      g.setColor(Color.red);
    else g.setColor(Color.black);
    g.drawLine((int)nodeFrom.x,(int)nodeFrom.y,(int)nodeTo.x,(int)nodeTo.y);
  }

}
