package graphelastic;

/**
 * Attributs publis des sommets.
 * @author <A href=http://www.alapetite.fr.st>Alexandre Alapetite</A>, <A href=http://www.andujar.fr.st>Brice Andujar</A>, <A href=mailto:gregory.gontier@free.fr>Gregory Gontier</A>
 * @version 1.1
 */
public interface SommetInterface
{
  /**
   * Accs  l'identifiant de ce sommet.
   */
  public int getIdentifiant();

  public boolean isCouleurOfficielle();

  /**
   * Texte  afficher pour ce sommet.
   */
  public String getLabel();

  /**
   * Accs  la couleur de ce sommet.
   */
  public int getCouleur();

  /**
   * Retourne si ce sommet est l'lu de son groupe.
   */
  public boolean isElu();

  /**
   * Indique si ce sommet est un fils du sommet de cet identifiant.
   */
  public boolean isFilsDe(int idPere);

}
